diff -urN trunk.org/clients/processor.py trunk/clients/processor.py
--- trunk.org/clients/processor.py	2018-06-21 01:27:34.000000000 +0200
+++ trunk/clients/processor.py	2020-02-23 19:09:16.715000000 +0100
@@ -4,7 +4,7 @@
 
 from trac.core import Component, implements
 from trac.wiki.api import IWikiMacroProvider
-from trac.wiki.formatter import wiki_to_html
+from trac.wiki.formatter import format_to_oneliner
 from trac.wiki.parser import WikiParser
 
 
@@ -22,7 +22,7 @@
     def expand_macro(self, formatter, name, content):
         return '<fieldset class="client"><legend>' \
                'Comments to Client</legend>%s</fieldset>' \
-               % wiki_to_html(content, self.env, formatter.req)
+               % format_to_oneliner(content, self.env, formatter.req)
 
 
 def extract_client_text(text, sep="----\n"):
@@ -67,4 +67,4 @@
                 ORDER BY version DESC LIMIT 1
                 """, ("WikiStart",)):
             text = extract_client_text(raw_text)
-            return wiki_to_html(text, self.env, formatter.req)
+            return format_to_oneliner(text, self.env, formatter.req)
diff -urN trunk.org/clients/summary_milestone.py trunk/clients/summary_milestone.py
--- trunk.org/clients/summary_milestone.py	2018-06-21 01:27:34.000000000 +0200
+++ trunk/clients/summary_milestone.py	2020-02-23 19:09:22.324000000 +0100
@@ -5,7 +5,7 @@
 
 from trac.core import Component, implements
 from trac.util.datefmt import format_date
-from trac.wiki import wiki_to_html
+from trac.wiki import format_to_oneliner
 
 from clients.summary import IClientSummaryProvider
 from clients.processor import extract_client_text
@@ -118,7 +118,7 @@
                             myformat_date(completed)
                     if mdescription:
                         wdescription = \
-                            wiki_to_html(extract_client_text(mdescription),
+                            format_to_oneliner(extract_client_text(mdescription),
                                          self.env, req)
                         xmilestone.append(
                             etree.XML('<description>%s</description>'
@@ -136,7 +136,7 @@
             ticket = etree.SubElement(xsummary, 'ticket')
             etree.SubElement(ticket, 'id').text = str(tid)
             etree.SubElement(ticket, 'summary').text = summary
-            text = wiki_to_html(extract_client_text(description),
+            text = format_to_oneliner(extract_client_text(description),
                                 self.env, req)
             ticket.append(etree.XML('<description>%s</description>' % text))
             etree.SubElement(ticket, 'status').text = status
diff -urN trunk.org/clients/summary_monthlyhours.py trunk/clients/summary_monthlyhours.py
--- trunk.org/clients/summary_monthlyhours.py	2018-06-21 01:27:34.000000000 +0200
+++ trunk/clients/summary_monthlyhours.py	2020-02-23 19:09:22.324000000 +0100
@@ -4,7 +4,7 @@
 
 from trac.core import Component, implements
 from trac.util.datefmt import format_date
-from trac.wiki import wiki_to_html
+from trac.wiki import format_to_oneliner
 
 from clients.summary import IClientSummaryProvider
 from clients.processor import extract_client_text
@@ -108,7 +108,7 @@
             etree.SubElement(ticket, 'id').text = str(tid)
             etree.SubElement(ticket, 'summary').text = summary
             ticket.append(etree.XML(
-                '<description>%s</description>' % wiki_to_html(
+                '<description>%s</description>' % format_to_oneliner(
                     extract_client_text(description), self.env, req)))
             etree.SubElement(ticket, 'status').text = status
             etree.SubElement(ticket, 'month').text = month
diff -urN trunk.org/clients/summary_ticketchanges.py trunk/clients/summary_ticketchanges.py
--- trunk.org/clients/summary_ticketchanges.py	2018-06-21 01:27:34.000000000 +0200
+++ trunk/clients/summary_ticketchanges.py	2020-02-23 19:09:22.324000000 +0100
@@ -2,7 +2,7 @@
 
 from trac.core import Component, implements
 from trac.util.datefmt import format_date
-from trac.wiki import wiki_to_html
+from trac.wiki import format_to_oneliner
 
 from lxml import etree
 from clients.summary import IClientSummaryProvider
@@ -129,7 +129,7 @@
                 etree.SubElement(ticket, 'id').text = str(tid)
                 etree.SubElement(ticket, 'summary').text = summary
                 ticket.append(etree.XML(
-                    '<description>%s</description>' % wiki_to_html(
+                    '<description>%s</description>' % format_to_oneliner(
                         extract_client_text(description), self.env, req)))
                 etree.SubElement(ticket, 'status').text = status
                 etree.SubElement(ticket, 'resolution').text = resolution
@@ -138,7 +138,7 @@
                 changelog = etree.SubElement(ticket, 'changelog')
 
             detail = etree.XML(
-                '<detail>%s</detail>' % wiki_to_html(text, self.env, req))
+                '<detail>%s</detail>' % format_to_oneliner(text, self.env, req))
             detail.set('field', cgfield)
             if oldvalue:
                 detail.set('oldvalue', oldvalue)